package de.joshavg

import javax.enterprise.context.ApplicationScoped
import javax.inject.Inject
import javax.ws.rs.core.Response

@ApplicationScoped
class Security(@Inject
                val builds: Builds) {

    fun requireKey(build: String, key: String?, block: (BuildConfig) -> Any): Response {
        val buildConfig = builds.buildConfig(build)
        if (buildConfig.key != key) {
            return Response.status(Response.Status.UNAUTHORIZED).build()
        }

        val entity = block(buildConfig)
        if(entity is Response) {
            return entity
        }

        return Response.ok(entity).build()
    }

}
